import { constantRouterMap } from '@/router/routers'
//import Layout from '@/layout/index'
import HomeLayout from "@/layout/home";
import ParentView from '@/components/ParentView'

const permission = {
  state: {
    routers: constantRouterMap,
    addRouters: [],
    sidebarRouters: []
  },
  mutations: {
    SET_ROUTERS: (state, routers) => {
      state.addRouters = routers
      state.routers = constantRouterMap.concat(routers)
    },
    SET_SIDEBAR_ROUTERS: (state, routers) => {
      state.sidebarRouters = constantRouterMap.concat(routers)
    }
  },
  actions: {
    GenerateRoutes({ commit }, asyncRouter) {
      commit('SET_ROUTERS', asyncRouter)
    },
    SetSidebarRouters({ commit }, sidebarRouter) {
      commit('SET_SIDEBAR_ROUTERS', sidebarRouter)
    }
  }
}

export const filterAsyncRouter = (routers, isRewrite = false, c, d) => { // 遍历后台传来的路由字符串，转换为组件对象
  return routers.filter(router => {
    if (isRewrite && router.children.length) {
		(router.children = filterChildren(router.children))
    }
    if (router.component) {
      if (router.component === 'Layout') { // Layout组件特殊处理
        //router.component = Layout;
		router.component = HomeLayout
      } else if (router.component === 'ParentView') {
        router.component = ParentView
      } else {
        const component = router.component;

        router.component = loadView(component, isRewrite)
      }
    }
    if (router.children && router.children.length) {
		//console.log('router.children 11111111 ________________ ', router.children, router.name);
		router.children = filterAsyncRouter(router.children, isRewrite, 1);
    }
    return true
  })
}

function filterChildren(childrenMap) {
  var children = [];
	//console.log('4444444444444 ________________ ', children);
  childrenMap.forEach((el, index) => {
    if (el.children && el.children.length) {
		//console.log('55555555555 ________________ ', el, el.component);
      if (el.component === 'ParentView') {
        //el.children.forEach(c => {
			//console.log('666666666666 ________________ ', c.path, el.path + '/' + c.path, c);

          //c.path = el.path + '/' + c.path;

		  //console.log('666666666666 ________________ ', c, c.path, c.name, c.children, c.children.length);

          //if (c.children && c.children.length) {
          //  children = children.concat(filterChildren(c.children, c));
          //  return
          //}
          //children.push(c);
		  //console.log('children ________________ ', children);
        //});
        //return 
      }
    }
    children = children.concat(el);
  })
  return children
}

export const loadView = (view, isRewrite) => {
	//console.log('loadView ________________ ', `@/views/${view}`, isRewrite);
	return function(resolve){
		return require([`@/views/${view}`], resolve);
	};
}

export default permission
